#!/usr/bin/perl
use locale;
print "Enter the file with the functional words\n";
$fwords = <STDIN>;
chomp $fwords;
open FWORDS, "$fwords";
@farray = <FWORDS>;
foreach (@farray) {
                chomp;
		s/$//g;		# converts to greek final -s 
		$_ = lc $_;	# converts to lower case
              }

print "Enter the path where the text files are:\nRemember to put double slashes (\\\\) or backslash (/)\n";
$dir = <STDIN>;
chomp $dir;
opendir(BIN, $dir) or die "Can't open $dir: $!";
open OUTFILE, ">Results.txt";
print OUTFILE ("Filename\tWords\tHapaxL\tDisL\tAWL\tFunctWords\tYuleK\tEntropy\tRelEntr\t1LW\t2LW\t3LW\t4LW\t5LW\t6LW\t7LW\t8LW\t9LW\t10LW\t11LW\t12LW\t13LW\t14LW\ta\tb\tc\td\te\tf\tg\th\ti\tj\tk\tl\tm\tn\to\tp\tq\tr\ts\tt\tu\tv\tw\tx\ty\tz\n");
while(defined ($file = readdir BIN)) {
			  next if $file =~ /^\.\.?$/;
			  next if $file =~ /pl$/;
			  next if $file =~ /pbp$/;
			  next if $file =~ /^Results\.txt/;
			  next if $file =~ /^fwords\.txt/;
  			  open(MYFILE, "$file");
              
 @array = ();
 %freqarray = ();
 %freqhash = ();
 %myconc = ();
 $word = 0;
 $freq = 0;
 $wordfr = 0;
 $M2 = 0;
 $M1 = 0;
 $Yule = 0;
 $times = 0;
 $p_i = 0;
 $logp_i = 0;
 $Entr = 0;
 $log_MaxE = 0;
 $RelEntr = 0;
 
              @array = <MYFILE>;
              foreach (@array) {
              	chomp;
		s/$//g;		# converts to greek final -s 
		$_ = lc $_;	# converts to lower case
              }
                foreach $word (@array) {        #creates a hash (myconc) with the frequency list of the array. 
                		$myconc{$word}++;
                }
$wordcount = @array;        
 while (($word, $freq) = each %myconc){           #search each value word - freq.
                                push @freqarray, $freq; #creates a hash with keys the frequency of a word and value the times this frequency occurs
				$freqhash{$freq}++;
				$p_i = $freq/$wordcount;	#calculates the p for each type
				$logp_i = log($p_i)/log(10);	#calculates the log(p) for each type
				$Entr += -($p_i * $logp_i);	# calculates the Entropy of the text
			  }
			  $log_MaxE = log ($wordcount) / log (10);	#calculates the maximum entropy of a text (that is if all the types occured once)
			  $RelEntr = 100*($Entr/$log_MaxE);	#Relative entropy = (Entropy of text / Maximum entropy) * 100


while (($wordfr, $times) = each %freqhash){           #search each value word - freq.
                               $M2 += $times * ($wordfr * $wordfr);
			       $M1 += $wordfr * $times;
			       }
 $Yule = 10000 * (($M2 - $M1)/($M1 * $M1));
 
 
 
 $hapax = 0;
 $dis = 0;
               while (($word, $freq) = each %myconc){           #search each value word - freq and if freq equal 1 (hapax legomeno) counts it in the $hapax. Same for the dislegomena ($dis)
                                if ($freq == 1) {
                                                $hapax +=1;
                                }
                                if ($freq == 2) {
                                                $dis +=1;
                                }
               
                } 

              

                         
                         
			  $text = join ("", @array);
$term = 0;
foreach (@farray) {
             $fw = $_;
			  for ($index = 1; $index <= $wordcount; $index++) { 
                                if ($array[$index-1] eq $fw) {
                                $term+=1;
                                }
			  }
}
			  
			  	

			  $char = 0;
			  $w1 = 0;
			  $w2 = 0;
			  $w3 = 0;
			  $w4 = 0;
			  $w5 = 0;
                          $w6 = 0;
                          $w7 = 0;
			  $w8 = 0;
			  $w9 = 0;
			  $w10 = 0;
			  $w11 = 0;
                          $w12 = 0;
                          $w13 = 0;
			  $w14 = 0;
			  $pw1 = 0;
			  $pw2 = 0;
			  $pw3 = 0;
			  $pw4 = 0;
			  $pw5 = 0;
                          $pw6 = 0;
                          $pw7 = 0;
			  $pw8 = 0;
			  $pw9 = 0;
			  $pw10 = 0;
			  $pw11 = 0;
                          $pw12 = 0;
                          $pw13 = 0;
			  $pw14 = 0;
			
                        for ($indexcount = 1; $indexcount <= $wordcount; $indexcount++) {	#Loops n times, where n the total number of the tokens
                		$x = length($array[$indexcount -1]); #Stores the length of each token in the variable x
                		   if ($x == 1) {	# The following if's check if the word length of x equals to a specified length
                		   $w1+=1;
                		   }
                		   if ($x == 2) {
                		   $w2+=1;
                		   }
                		   if ($x == 3) {
                		   $w3+=1;
                		   }
                		   if ($x == 4) {
                		   $w4+=1;
                		   }
                		   if ($x == 5) {
                		   $w5+=1;
                		   }
                		   if ($x == 6) {
                		   $w6+=1;
                		   }
                		   if ($x == 7) {
                		   $w7+=1;
                		   }
                		   if ($x == 8) {
                		   $w8+=1;
                		   }
                		   if ($x == 9) {
                		   $w9+=1;
                		   }
                		    if ($x == 10) {
                		   $w10+=1;
                		   }
                		   if ($x == 11) {
                		   $w11+=1;
                		   }
                		   if ($x == 12) {
                		   $w12+=1;
                		   }
                		   if ($x == 13) {
                		   $w13+=1;
                		   }
                		   if ($x == 14) {
                		   $w14+=1;
                		   }
                		$char += $x;	#Sums the lengths
                		}

$pw1 = ($w1 * 100) / $wordcount;
$pw2 = ($w2 * 100) / $wordcount;
$pw3 = ($w3 * 100) / $wordcount;
$pw4 = ($w4 * 100) / $wordcount;
$pw5 = ($w5 * 100) / $wordcount;
$pw6 = ($w6 * 100) / $wordcount;
$pw7 = ($w7 * 100) / $wordcount;
$pw8 = ($w8 * 100) / $wordcount;
$pw9 = ($w9 * 100) / $wordcount;
$pw10 = ($w10 * 100) / $wordcount;
$pw11 = ($w11 * 100) / $wordcount;
$pw12 = ($w12 * 100) / $wordcount;
$pw13 = ($w13 * 100) / $wordcount;
$pw14 = ($w14 * 100) / $wordcount;


$awl = $char/$wordcount;

			  $a = ($text =~ tr/a//);
			  $b = ($text =~ tr/b//);
			  $c = ($text =~ tr/c//);
			  $d = ($text =~ tr/d//);
			  $e = ($text =~ tr/e//);
			  $f = ($text =~ tr/f//);
			  $g = ($text =~ tr/g//);
			  $h = ($text =~ tr/h//);
			  $i = ($text =~ tr/i//);
			  $j = ($text =~ tr/j//);
			  $k = ($text =~ tr/k//);
			  $l = ($text =~ tr/l//);
			  $m = ($text =~ tr/m//);
			  $n = ($text =~ tr/n//);
			  $o = ($text =~ tr/o//);
			  $p = ($text =~ tr/p//);
			  $q = ($text =~ tr/q//);
			  $r = ($text =~ tr/r//);
			  $s = ($text =~ tr/s//);
			  $t = ($text =~ tr/t//);
			  $u = ($text =~ tr/u//);
			  $v = ($text =~ tr/v//);
			  $w = ($text =~ tr/w//);
			  $x = ($text =~ tr/x//);
			  $y = ($text =~ tr/y//);
			  $z = ($text =~ tr/z//);
			  
			  
			  

$chartotal = $a+$b+$c+$d+$e+$f+$g+$h+$i+$j+$k+$l+$m+$n+$o+$p+$q+$r+$s+$t+$u+$v+$w+$x+$y+$z;
			  $p_a = ($a*100)/$chartotal;
		  $p_b = ($b*100)/$chartotal;
			  $p_c = ($c*100)/$chartotal;
			  $p_d = ($d*100)/$chartotal;
			  $p_e = ($e*100)/$chartotal;
			  $p_f = ($f*100)/$chartotal;
			  $p_g = ($g*100)/$chartotal;
			  $p_h = ($h*100)/$chartotal;
			  $p_i = ($i*100)/$chartotal;
			  $p_j = ($j*100)/$chartotal;
			  $p_k = ($k*100)/$chartotal;
			  $p_l = ($l*100)/$chartotal;
			  $p_m = ($m*100)/$chartotal;
			  $p_n = ($n*100)/$chartotal;
			  $p_o = ($o*100)/$chartotal;
			  $p_p = ($p*100)/$chartotal;
			  $p_q = ($q*100)/$chartotal;
			  $p_r = ($r*100)/$chartotal;
			  $p_s = ($s*100)/$chartotal;
			  $p_t = ($t*100)/$chartotal;
			  $p_u = ($u*100)/$chartotal;
			  $p_v = ($v*100)/$chartotal;
			  $p_w = ($w*100)/$chartotal;
			  $p_x = ($x*100)/$chartotal;
			  $p_y = ($y*100)/$chartotal;
			  $p_z = ($z*100)/$chartotal;


print OUTFILE ("$file\t$wordcount\t$hapax\t$dis\t$awl\t$term\t$Yule\t$Entr\t$RelEntr\t$pw1\t$pw2\t$pw3\t$pw4\t$pw5\t$pw6\t$pw7\t$pw8\t$pw9\t$pw10\t$pw11\t$pw12\t$pw13\t$pw14\t$p_a\t$p_b\t$p_c\t$p_d\t$p_e\t$p_f\t$p_g\t$p_h\t$p_i\t$p_j\t$p_k\t$p_l\t$p_m\t$p_n\t$p_o\t$p_p\t$p_q\t$p_r\t$p_s\t$p_t\t$p_u\t$p_v\t$p_w\t$p_x\t$p_y\t$p_z\n");

}


close OUTFILE;
closedir(BIN);